<template>
  <div>
    <vue-p5 v-on="{setup,draw,keypressed}"></vue-p5>
  </div>
</template>

<script>
import VueP5 from "vue-p5";
import * as ml5 from "ml5";
export default {
  name: "Trial",
  components: {
    "vue-p5": VueP5
  },
  data() {
    return {
      video: "",
      poseNet: "",
      pose: "",
      skeleton: "",
      brain: {}
      // state: "waiting",
      // targetLabel: ""
    };
  },
  methods: {
    keypressed(sketch) {
      if (sketch.key == "s") {
        this.brain.saveData();
      } else {
        this.targetLabel = sketch.key;
        console.log(this.targetLabel);
        setTimeout(() => {
          console.log("collecting");
          this.state = "collecting";
          setTimeout(() => {
            console.log("not collecting");
            this.state = "waiting";
          }, 10000);
        }, 10000);
      }
    },
    setup(sketch) {
      sketch.createCanvas(640, 480);
      this.video = sketch.createCapture(sketch.VIDEO);
      this.video.hide();
      this.poseNet = ml5.poseNet(this.video, this.modelLoaded);
      this.poseNet.on("pose", this.gotPoses);
      let options = {
        inputs: 34,
        outputs: 3,
        task: "classification",
        debug: true
      };
      this.brain = ml5.neuralNetwork(options);
      const modelInfo = {
        model: "http://bot.issett.com/images/uploads/model.json",
        metadata: "http://bot.issett.com/images/uploads/model_meta.json",
        weights: "http://bot.issett.com/images/uploads/model.weights.bin"
      };
      // console.log(modelInfo);
      //  /* eslint-disable */
      // debugger
      this.brain.load(modelInfo, this.brainLoaded);
      //   this.brain.loadData('recentexercise.json',this.dataReady);
    },
    classifyPose() {
      if (this.pose ) {
        let inputs = [];
        for (let i = 0; i < this.pose.keypoints.length; i++) {
          let x = this.pose.keypoints[i].position.x;
          let y = this.pose.keypoints[i].position.y;
          inputs.push(x);
          inputs.push(y);
        }
        this.brain.classify(inputs, this.gotResult);
      } else {
        setTimeout(this.classifyPose, 100);
      }
    },
    brainLoaded() {
      console.log("Pose Classification Ready");
      this.classifyPose;
    },
    gotResult(error, results) {
      if (results) {
        console.log(results);
        console.log(results[0].label);
      } else {
        console.log(error);
      }
      this.classifyPose;
    },
    // dataReady() {
    //   this.brain.normalizeData();
    //   this.brain.train({ epoch: 50 }, this.finished);
    // },
    // finished() {
    //   console.log("Model is trained");
    //   this.brain.save();
    // },
    gotPoses(poses) {
      //   console.log(poses);
      if (poses.length > 0) {
        this.pose = poses[0].pose;
        this.skeleton = poses[0].skeleton;
        if (this.state == "collecting") {
          let inputs = [];
          for (let i = 0; i < this.pose.keypoints.length; i++) {
            let x = this.pose.keypoints[i].position.x;
            let y = this.pose.keypoints[i].position.y;
            inputs.push(x);
            inputs.push(y);
          }
          let target = [this.targetLabel];
          this.brain.addData(inputs, target);
        }
      }
    },
    modelLoaded() {
      console.log("Model is loaded");
    },
    draw(sketch) {
      sketch.translate(this.video.width, 0, 0);
      sketch.scale(-1, 1);
      sketch.image(this.video, 0, 0);
      if (this.pose) {
        for (let i = 0; i < this.pose.keypoints.length; i++) {
          let x = this.pose.keypoints[i].position.x;
          let y = this.pose.keypoints[i].position.y;
          sketch.fill(0);
          sketch.ellipse(x, y, 16, 16);
        }
        for (let i = 0; i < this.skeleton.length; i++) {
          let a = this.skeleton[i][0];
          let b = this.skeleton[i][1];
          sketch.strokeWeight(2);
          sketch.stroke(0);
          sketch.line(a.position.x, a.position.y, b.position.x, b.position.y);
        }
      }
    }
  }
  // mounted(){
  //   this.classifyPose();
  // }
};
</script>

<style lang="scss" scoped>
</style>